KillingSpree = AceLibrary("AceAddon-2.0"):new("AceConsole-2.0", "AceEvent-2.0", "AceDB-2.0", "Parser-3.0", "FuBarPlugin-2.0");
KillingSpree.sharedmedia = AceLibrary("SharedMedia-1.0");
KillingSpree.waterfall = AceLibrary("Waterfall-1.0");
KillingSpree.dewdrop = AceLibrary("Dewdrop-2.0");
KillingSpree.tablet = AceLibrary("Tablet-2.0");
KillingSpree.title = "Killing Spree";
KillingSpree.debug = false;
KillingSpree.locked = true;
KillingSpree.hasIcon = true;
KillingSpree.hasNoText = true;
KillingSpree.hasNoColor = true;
KillingSpree.overrideMenu = true;
KillingSpree.hideMenuTitle = true;
KillingSpree.canDetachTooltip = true;
KillingSpree.defaultPosition = "MINIMAP";
KillingSpree.defaultMinimapPosition = 225;

local SOUND_SCHEME = {
	["Taunts"] = {
		[1] = {"bam.wav", "BAM!"},
		[2] = {"chickenlol.wav", "LOL /chicken!"},
		[3] = {"crap.wav", "Aww crap, you died!"},
		[4] = {"danceallday.wav", "I can dance all day!"},
		[5] = {"doh.wav", "Doh, you died!"},
		[6] = {"fuckinlag.wav", "Fuckin lag!"},
		[7] = {"haha.wav", "Ha ha, you died!"},
		[8] = {"hahanoobs", "Ha ha, noobs!"},
		[9] = {"headshot.wav", "Boom, headshot!"},
		[10] = {"headshotslow.wav", "Boooom, headshot!"},
		[11] = {"ious.wav", "Its official, you suck!"},
		[12] = {"lawl.wav", "LOL, you died!"},
		[13] = {"noob.wav", "Noob, you died!"},
		[14] = {"nothing.wav", "You own nothing!"},
		[15] = {"pathetic.wav", "That was pathetic!"},
		[16] = {"slap.wav", "/slap, you died!"},
		[17] = {"weak.wav", "You weak pathetic fool!"},
		[18] = {"yeah.wav", "Oh yeah, you died!"},
		[19] = {"youarenothing.wav", "You are nothing!"},
		[20] = {"you likethat.wav", "You like that, dont you!"},
	},
	["UT2k3"] = {
		[1] = {"firstblood.wav", "First Blood!"},
		[2] = {"doublekill.wav", "Double Kill!"},
		[3] = {"multikill.wav", "Multi Kill!"},
		[4] = {"ultrakill.wav", "Ultra Kill!"},
		[5] = {"monsterkill.wav", "Monster Kill!"},
		[10] = {"killingspree.wav", "Killing Spree!"},
		[15] = {"rampage.wav", "Rampage!"},
		[20] = {"dominating.wav", "Dominating!"},
		[25] = {"unstoppable.wav", "Unstoppable!"},
		[30] = {"godlike.wav", "God-like!"},
	},
	["UT2k4"] = {
		[1] = {"firstblood.wav", "First Blood!"},
		[2] = {"doublekill.wav", "Double Kill!"},
		[3] = {"multikill.wav", "Multi Kill!"},
		[4] = {"megakill.wav", "Mega Kill!"},
		[5] = {"ultrakill.wav", "Ultra Kill!"},
		[6] = {"monsterkill.wav", "Monster Kill!"},
		[7] = {"ludicrouskill.wav", "Ludicrous Kill!"},
		[8] = {"holyshit.wav", "Holy Shit!"},
		[10] = {"killingspree.wav", "Killing Spree!"},
		[15] = {"rampage.wav", "Rampage!"},
		[20] = {"dominating.wav", "Dominating!"},
		[25] = {"unstoppable.wav", "Unstoppable!"},
		[30] = {"godlike.wav", "God-like!"},
		[35] = {"wickedsick.wav", "Wicked Sick!"},
	},
	["UT2k4Female"] = {
		[1] = {"firstblood.wav", "First Blood!"},
		[2] = {"doublekill.wav", "Double Kill!"},
		[3] = {"multikill.wav", "Multi Kill!"},
		[4] = {"megakill.wav", "Mega Kill!"},
		[5] = {"ultrakill.wav", "Ultra Kill!"},
		[6] = {"monsterkill.wav", "Monster Kill!"},
		[7] = {"ludicrouskill.wav", "Ludicrous Kill!"},
		[8] = {"holyshit.wav", "Holy Shit!"},
		[10] = {"killingspree.wav", "Killing Spree!"},
		[15] = {"rampage.wav", "Rampage!"},
		[20] = {"dominating.wav", "Dominating!"},
		[25] = {"unstoppable.wav", "Unstoppable!"},
		[30] = {"godlike.wav", "God-like!"},
		[35] = {"wickedsick.wav", "Wicked Sick!"},
	},
};

local PARSER_FILTER = {
	["PLAYER_DEAD"] = {
		eventType = "Death",
		sourceName_not = false,
		recipientID = "player",
		recipientName_not = false,
		isItem= false,
	},
	["HOSTILE_DEAD"] = {
		eventType = "Death",
		sourceName_not = false,
		recipientID_not = "player",
		recipientName_not = false,
		isItem = false,
	},
	["HOSTILE_DEAD_SELF"] = {
		eventType = "Death",
		sourceID_in = { "player", "pet" },
		sourceName_not = false,
		recipientID_not = "player",
		recipientName_not = false,
		isItem = false,
	},
	["PLAYER_DEAD_PVP"] = {
		eventType = "Death",
		sourceName_not = false,
		sourcePvP = true,
		recipientID = "player",
		recipientName_not = false,
		recipientPvP = true,
		isItem = false,
	},
	["HOSTILE_DEAD_PVP"] = {
		eventType = "Death",
		sourceName_not = false,
		sourcePvP = true,
		recipientID_not = "player",
		recipientName_not = false,
		recipientPvP = true,
		isItem = false,
	},
	["HOSTILE_DEAD_SELF_PVP"] = {
		eventType = "Death",
		sourceID_in = { "player", "pet" },
		sourceName_not = false,
		sourcePvP = true,
		recipientID_not = "player",
		recipientName_not = false,
		recipientPvP = true,
		isItem = false,
	},
};

function KillingSpree:OnInitialize()
	local scheme = nil;
	if UnitSex("player") == 3 then
		scheme = "UT2k4Female";
	else
		scheme = "UT2k4";
	end
	self.options = {
		type = 'group',
		args = {
			config = {
				order = 1,
				type = 'execute',
				name = 'Configuration Dialog',
				desc = 'Opens the configuration dialog',
				func = function()
					if self.waterfall:IsOpen("KillingSpreeConfig") then
						self.waterfall:Close("KillingSpreeConfig");
					else
						self.waterfall:Open("KillingSpreeConfig");
					end
				end,
				wfHidden = true,
				guiHidden = true,
			},
			record = {
				order = 2,
				type = 'execute',
				name = 'Display Records',
				desc = 'Displays the multi and spree records',
				func = function()
					self:Print("multi-kill record: " .. self.db.char.multi .. ".");
					self:Print("spree-kill record: " .. self.db.char.spree .. ".");
				end,
			},
			reset = {
				order = 3,
				type = 'execute',
				name = 'Reset Records',
				desc = 'Resets the multi and spree records',
				func = function()
					self.db.char.multi = 0;
					self.db.char.spree = 0;
					self:SetAddonVariables();
					self:UpdateTooltip();
				end,
				hidden = function()
					return self.db.char.multi + self.db.char.spree == 0;
				end,
			},
			header1 = {
				order = 100,
				type = "header",
			},
			debug = {
				order = 101,
				type = 'toggle',
				name = 'Debugging',
				desc = 'Toggles addon debugging',
				get = function()
					return self.db.profile.debug;
				end,
				set = function(debug)
					if self.db.profile.debug ~= debug then
						self.db.profile.debug = debug;
					end
				end,
				hidden = function()
					return not self.debug;
				end,
			},
			mtimer = {
				order = 102,
				type = 'text',
				name = 'Multi Timer',
				desc = 'Sets the multikill timer',
				usage = '<seconds>',
				get = function()
					return self.db.profile.mtimer;
				end,
				set = function(mtimer)
					self.db.profile.mtimer = tonumber(mtimer);
					self:SetAddonVariables();
					self:UpdateTooltip();
				end,
			},
			scheme = {
				order = 103,
				type = 'text',
				name = 'Sound Scheme',
				desc = 'Changes the sound scheme',
				usage = '<scheme>',
				get = function()
					return self.db.profile.scheme;
				end,
				set = function(scheme)
					self.db.profile.scheme = scheme;
					PlaySoundFile("Interface\\AddOns\\KillingSpree\\snds\\" .. self.db.profile.scheme .. "\\" .. SOUND_SCHEME[self.db.profile.scheme][1][1]);
				end,
				validate = { "UT2k3", "UT2k4", "UT2k4Female" },
			},
			taunts = {
				order = 104,
				type = 'toggle',
				name = 'Play Taunts',
				desc = 'Toggles playing taunts',
				get = function()
					return self.db.profile.taunts;
				end,
				set = function(taunts)
					self.db.profile.taunts = taunts;
					if self.db.profile.taunts then
						if self.db.profile.pvp then
							self:RegisterParserEvent(PARSER_FILTER["PLAYER_DEAD_PVP"], "PLAYER_DEAD");
						else
							self:RegisterParserEvent(PARSER_FILTER["PLAYER_DEAD"], "PLAYER_DEAD");
						end
					elseif self:IsParserEventRegistered(PARSER_FILTER["PLAYER_DEAD_PVP"]) then
						self:UnregisterParserEvent(PARSER_FILTER["PLAYER_DEAD_PVP"]);
					elseif self:IsParserEventRegistered(PARSER_FILTER["PLAYER_DEAD"]) then
						self:UnregisterParserEvent(PARSER_FILTER["PLAYER_DEAD"]);
					end
				end,
			},
			sounds = {
				order = 105,
				type = 'toggle',
				name = 'Play Sounds',
				desc = 'Toggles playing sounds',
				get = function()
					return self.db.profile.sounds;
				end,
				set = function(sounds)
					self.db.profile.sounds = sounds;
				end,
			},
			visuals = {
				order = 106,
				type = 'toggle',
				name = 'Pulse Screen',
				desc = 'Toggles screen pulsing',
				get = function()
					return self.db.profile.visuals;
				end,
				set = function(visuals)
					self.db.profile.visuals = visuals;
					if self.db.profile.visuals then
						UIFrameFlash(LowHealthFrame, 0.25, 0.25, 0.5, false, 0, 0);
					end
				end,
			},
			shared = {
				order = 107,
				type = 'toggle',
				name = 'Broadcasting',
				desc = 'Toggles spree broadcasting',
				get = function()
					return self.db.profile.shared;
				end,
				set = function(shared)
					if self.db.profile.shared ~= shared then
						self.db.profile.shared = shared;
						if self.db.profile.shared then
							self:RegisterEvent("CHAT_MSG_ADDON");
						elseif self:IsEventRegistered("CHAT_MSG_ADDON") then
							self:UnregisterEvent("CHAT_MSG_ADDON");
						end
					end
				end,
			},
			slain = {
				order = 108,
				type = 'toggle',
				name = 'Slain By',
				desc = 'Toggles slain by check',
				get = function()
					return self.db.profile.slain;
				end,
				set = function(slain)
					if self.db.profile.slain ~= slain then
						self.db.profile.slain = slain;
						if self.db.profile.slain and self.db.profile.pvp then
							if self:IsParserEventRegistered(PARSER_FILTER["HOSTILE_DEAD_SELF"]) then
								self:UnregisterParserEvent(PARSER_FILTER["HOSTILE_DEAD_SELF"]);
							elseif self:IsParserEventRegistered(PARSER_FILTER["HOSTILE_DEAD_PVP"]) then
								self:UnregisterParserEvent(PARSER_FILTER["HOSTILE_DEAD_PVP"]);
							elseif self:IsParserEventRegistered(PARSER_FILTER["HOSTILE_DEAD"]) then
								self:UnregisterParserEvent(PARSER_FILTER["HOSTILE_DEAD"]);
							end
							self:RegisterParserEvent(PARSER_FILTER["HOSTILE_DEAD_SELF_PVP"], "HOSTILE_DEAD");
						elseif self.db.profile.slain then
							if self:IsParserEventRegistered(PARSER_FILTER["HOSTILE_DEAD_SELF_PVP"]) then
								self:UnregisterParserEvent(PARSER_FILTER["HOSTILE_DEAD_SELF_PVP"]);
							elseif self:IsParserEventRegistered(PARSER_FILTER["HOSTILE_DEAD_PVP"]) then
								self:UnregisterParserEvent(PARSER_FILTER["HOSTILE_DEAD_PVP"]);
							elseif self:IsParserEventRegistered(PARSER_FILTER["HOSTILE_DEAD"]) then
								self:UnregisterParserEvent(PARSER_FILTER["HOSTILE_DEAD"]);
							end
							self:RegisterParserEvent(PARSER_FILTER["HOSTILE_DEAD_SELF"], "HOSTILE_DEAD");
						elseif self.db.profile.pvp then
							if self:IsParserEventRegistered(PARSER_FILTER["HOSTILE_DEAD_SELF_PVP"]) then
								self:UnregisterParserEvent(PARSER_FILTER["HOSTILE_DEAD_SELF_PVP"]);
							elseif self:IsParserEventRegistered(PARSER_FILTER["HOSTILE_DEAD_SELF"]) then
								self:UnregisterParserEvent(PARSER_FILTER["HOSTILE_DEAD_SELF"]);
							elseif self:IsParserEventRegistered(PARSER_FILTER["HOSTILE_DEAD"]) then
								self:UnregisterParserEvent(PARSER_FILTER["HOSTILE_DEAD"]);
							end
							self:RegisterParserEvent(PARSER_FILTER["HOSTILE_DEAD_PVP"], "HOSTILE_DEAD");
						else
							if self:IsParserEventRegistered(PARSER_FILTER["HOSTILE_DEAD_SELF_PVP"]) then
								self:UnregisterParserEvent(PARSER_FILTER["HOSTILE_DEAD_SELF_PVP"]);
							elseif self:IsParserEventRegistered(PARSER_FILTER["HOSTILE_DEAD_SELF"]) then
								self:UnregisterParserEvent(PARSER_FILTER["HOSTILE_DEAD_SELF"]);
							elseif self:IsParserEventRegistered(PARSER_FILTER["HOSTILE_DEAD_PVP"]) then
								self:UnregisterParserEvent(PARSER_FILTER["HOSTILE_DEAD_PVP"]);
							end
							self:RegisterParserEvent(PARSER_FILTER["HOSTILE_DEAD"], "HOSTILE_DEAD");
						end
						self:SetAddonVariables();
						self:UpdateTooltip();
					end
				end,
			},
			pvp = {
				order = 109,
				type = 'toggle',
				name = 'PvP Only',
				desc = 'Toggles PvP check',
				get = function()
					return self.db.profile.pvp;
				end,
				set = function(pvp)
					if self.db.profile.pvp ~= pvp then
						self.db.profile.pvp = pvp;
						if self.db.profile.slain and self.db.profile.pvp then
							if self:IsParserEventRegistered(PARSER_FILTER["HOSTILE_DEAD_SELF"]) then
								self:UnregisterParserEvent(PARSER_FILTER["HOSTILE_DEAD_SELF"]);
							elseif self:IsParserEventRegistered(PARSER_FILTER["HOSTILE_DEAD_PVP"]) then
								self:UnregisterParserEvent(PARSER_FILTER["HOSTILE_DEAD_PVP"]);
							elseif self:IsParserEventRegistered(PARSER_FILTER["HOSTILE_DEAD"]) then
								self:UnregisterParserEvent(PARSER_FILTER["HOSTILE_DEAD"]);
							end
							self:RegisterParserEvent(PARSER_FILTER["HOSTILE_DEAD_SELF_PVP"], "HOSTILE_DEAD");
						elseif self.db.profile.slain then
							if self:IsParserEventRegistered(PARSER_FILTER["HOSTILE_DEAD_SELF_PVP"]) then
								self:UnregisterParserEvent(PARSER_FILTER["HOSTILE_DEAD_SELF_PVP"]);
							elseif self:IsParserEventRegistered(PARSER_FILTER["HOSTILE_DEAD_PVP"]) then
								self:UnregisterParserEvent(PARSER_FILTER["HOSTILE_DEAD_PVP"]);
							elseif self:IsParserEventRegistered(PARSER_FILTER["HOSTILE_DEAD"]) then
								self:UnregisterParserEvent(PARSER_FILTER["HOSTILE_DEAD"]);
							end
							self:RegisterParserEvent(PARSER_FILTER["HOSTILE_DEAD_SELF"], "HOSTILE_DEAD");
						elseif self.db.profile.pvp then
							if self:IsParserEventRegistered(PARSER_FILTER["HOSTILE_DEAD_SELF_PVP"]) then
								self:UnregisterParserEvent(PARSER_FILTER["HOSTILE_DEAD_SELF_PVP"]);
							elseif self:IsParserEventRegistered(PARSER_FILTER["HOSTILE_DEAD_SELF"]) then
								self:UnregisterParserEvent(PARSER_FILTER["HOSTILE_DEAD_SELF"]);
							elseif self:IsParserEventRegistered(PARSER_FILTER["HOSTILE_DEAD"]) then
								self:UnregisterParserEvent(PARSER_FILTER["HOSTILE_DEAD"]);
							end
							self:RegisterParserEvent(PARSER_FILTER["HOSTILE_DEAD_PVP"], "HOSTILE_DEAD");
						else
							if self:IsParserEventRegistered(PARSER_FILTER["HOSTILE_DEAD_SELF_PVP"]) then
								self:UnregisterParserEvent(PARSER_FILTER["HOSTILE_DEAD_SELF_PVP"]);
							elseif self:IsParserEventRegistered(PARSER_FILTER["HOSTILE_DEAD_SELF"]) then
								self:UnregisterParserEvent(PARSER_FILTER["HOSTILE_DEAD_SELF"]);
							elseif self:IsParserEventRegistered(PARSER_FILTER["HOSTILE_DEAD_PVP"]) then
								self:UnregisterParserEvent(PARSER_FILTER["HOSTILE_DEAD_PVP"]);
							end
							self:RegisterParserEvent(PARSER_FILTER["HOSTILE_DEAD"], "HOSTILE_DEAD");
						end
						self:SetAddonVariables();
						self:UpdateTooltip();
					end
				end,
			},
			range = {
				order = 110,
				type = 'text',
				name = 'Events Range',
				desc = 'Changes the combat event range',
				get = function()
					return self.db.profile.range;
				end,
				set = function(range)
					self.db.profile.range = range;
					self:SetCombatLogRange(range);
				end,
				validate = {
					["minimum"] = "Minumum",
					["default"] = "Default",
					["optimum"] = "Optimum",
					["maximum"] = "Maximum",
				},
			},
			frame = {
				order = 111,
				type = 'text',
				name = 'Message Frame',
				desc = 'Choose the message frame to use',
				get = function()
					return self.db.profile.frame;
				end,
				set = function(frame)
					if (frame == "msbt" and IsAddOnLoaded("MikScrollingBattleText")) or (frame == "sct" and IsAddOnLoaded("sct")) or (frame == "blizzard" and UIOptionsFrameCheckButtons["SHOW_COMBAT_TEXT_TEXT"].value == "1") or (frame == "parrot" and IsAddOnLoaded("Parrot")) or frame == "default" then
						self.db.profile.frame = frame;
					else
						self:Print("frame isnt usable!");
					end
				end,
				validate = {
					["blizzard"]	= "Blizzard",
					["default"] = "Default",
					["parrot"] = "Parrot",
					["msbt"] = "MSBT",
					["sct"] = "SCT",
				},
			},
			header2 = {
				order = 200,
				type = "header",
				hidden = function()
					return self.db.profile.frame ~= "default";
				end,
			},
			unlock = {
				order = 201,
				type = 'toggle',
				name = 'Unlock Frame',
				desc = 'Unlocks the message frame',
				get = function()
				return not self.locked;
				end,
				set = function()
					self.locked = not self.locked;
					self:ToggleMessageFrame();
				end,
				hidden = function()
					return self.db.profile.frame ~= "default";
				end,
			},
			fontcolor = {
				order = 202,
				type = 'color',
				name = 'Font Color',
				desc = 'Changes the message font color',
				get = function()
					return self.db.profile.fontcolor[r], self.db.profile.fontcolor[g], self.db.profile.fontcolor[b];
				end,
				set = function(red, green, blue)
					self.db.profile.fontcolor = {
						r = red,
						g = green,
						b = blue,
					};
					self.MessageFrame:SetTextColor(self.db.profile.fontcolor.r, self.db.profile.fontcolor.g, self.db.profile.fontcolor.b);
					self:Announce("New font color selected");
				end,
			},
			fontsize = {
				order = 203,
				type = 'text',
				name = 'Font Size',
				desc = 'Changes the message font size',
				get = function()
					return self.db.profile.fontsize;
				end,
				set = function(fontsize)
					self.db.profile.fontsize = fontsize;
					local type, size, outline = self.MessageFrame:GetFont();
					self.MessageFrame:SetFont(type, tonumber(fontsize), outline);
					self:Announce("New font size selected");
				end,
				hidden = function()
					return self.db.profile.frame ~= "default";
				end,
				validate = {
					["16"] = "Tiny",
					["24"] = "Small",
					["32"] = "Medium",
					["48"] = "Large",
				},
			},
			fonttype = {
				order = 204,
				type = 'text',
				name = 'Font Type',
				desc = 'Changes the message font type',
				get = function()
					return self.db.profile.fonttype;
				end,
				set = function(fonttype)
					self.db.profile.fonttype = fonttype;
					local type, size, outline = self.MessageFrame:GetFont();
					self.MessageFrame:SetFont(self.sharedmedia:Fetch('font', fonttype), math.floor(size+0.5), outline);
					self:Announce("New font type selected");
				end,
				hidden = function()
					return self.db.profile.frame ~= "default";
				end,
				validate = self.sharedmedia:List("font"),
			},
			fontoutline = {
				order = 205,
				type = 'text',
				name = 'Font Outline',
				desc = 'Changes the message font outline',
				get = function()
					return self.db.profile.fontoutline;
				end,
				set = function(fontoutline)
					self.db.profile.fontoutline = fontoutline;
					local type, size, outline = self.MessageFrame:GetFont();
					self.MessageFrame:SetFont(type, math.floor(size+0.5), fontoutline);
					self:Announce("New font outline selected");
				end,
				hidden = function()
					return self.db.profile.frame ~= "default";
				end,
				validate = {
					[""] = "None",
					["OUTLINE"] = "Thin",
					["THICKOUTLINE"] = "Thick",
				},
			},
		},
	};
	self:RegisterDB('KillingSpreeDB', 'KillingSpreePCDB');
	self:RegisterDefaults('profile', {
		debug = self.debug,
		mtimer = 60,
		scheme = scheme,
		sounds = true,
		visuals = true,
		shared = true,
		slain = true,
		pvp = true,
		x = 0,
		y = 150,
		range = "default",
		frame = "default",
		fonttype = "Skurri",
		fontsize = "32",
		fontoutline = "",
		fontcolor = {
			r = 1,
			b = 1,
			g = 1,
		},
	});
	self:RegisterDefaults('char', {
		multi = 0,
		spree = 0,
	});
	self:CreateMessageFrame();
	self:ToggleMessageFrame();
	self:RegisterChatCommand({'/killingspree', '/ks'}, self.options);
	self.waterfall:Register("KillingSpreeConfig", "title", "Killing Spree Config", "aceOptions", self.options);
end

function KillingSpree:OnEnable()
	self:SetAddonVariables();
	self:UpdateTooltip();
	self:SetCombatLogRange(self.db.profile.range);
	self:RegisterEvent("PLAYER_ENTERING_WORLD");
	if self.db.profile.shared then
		self:RegisterEvent("CHAT_MSG_ADDON");
	end
	if self.db.profile.taunts then
		self:RegisterParserEvent(PARSER_FILTER["PLAYER_DEAD"], "PLAYER_DEAD");
	end
	if self.db.profile.slain and self.db.profile.pvp then
		self:RegisterParserEvent(PARSER_FILTER["HOSTILE_DEAD_SELF_PVP"], "HOSTILE_DEAD");
	elseif self.db.profile.slain then
		self:RegisterParserEvent(PARSER_FILTER["HOSTILE_DEAD_SELF"], "HOSTILE_DEAD");
	elseif self.db.profile.pvp then
		self:RegisterParserEvent(PARSER_FILTER["HOSTILE_DEAD_PVP"], "HOSTILE_DEAD");
	else
		self:RegisterParserEvent(PARSER_FILTER["HOSTILE_DEAD"], "HOSTILE_DEAD");
	end
end

function KillingSpree:OnDisable()
	self:UnregisterAllEvents();
	self:UnregisterAllParserEvents();
end

function KillingSpree:OnClick()
	if self.waterfall:IsOpen("KillingSpreeConfig") then
		self.waterfall:Close("KillingSpreeConfig");
	else
		self.waterfall:Open("KillingSpreeConfig");
	end
end

function KillingSpree:OnMenuRequest(level, value, inTooltip)
	if not inTooltip then
		self.dewdrop:FeedAceOptionsTable(self.options);
	end
end

function KillingSpree:OnTooltipUpdate()
	local multi = 0;
	local spree = 0;
	local victims = nil;
	if self.db.profile.slain then
		victims = self.tablet:AddCategory('columns', 2);
	else
		victims = self.tablet:AddCategory('columns', 1);
	end
	for victim = self.kills, 0, -1 do
		if self.victims[victim] and self.victims[victim].announced then
			if tonumber(self.db.profile.mtimer) > 0 and time() - self.victims[victim].tod < tonumber(self.db.profile.mtimer) then
				multi = multi + 1;
			else
				spree = spree + 1;
			end
		end
	end
	if multi ~= self.multi or spree ~= self.spree or mtimer == 0 then
		self.multi = multi;
		self.spree = spree + multi;
		for victim = self.kills, 0, -1 do
			if self.victims[victim] and self.victims[victim].announced then
				if tonumber(self.db.profile.mtimer) > 0 and time() - self.victims[victim].tod < tonumber(self.db.profile.mtimer) then
					if self.db.profile.slain then
						victims:AddLine('text', self.victims[victim].name, 'justify', "LEFT", 'textR', 1, 'textG', 0, 'textB', 0, 'text2', self.victims[victim].slayer, 'justify2', "RIGHT", 'text2R', 1, 'text2G', 0, 'text2B', 0);
					else
						victims:AddLine('text', self.victims[victim].name, 'justify', "LEFT", 'textR', 1, 'textG', 0, 'textB', 0);
					end
				else
					if self.db.profile.slain then
						victims:AddLine('text', self.victims[victim].name, 'justify', "LEFT", 'textR', 1, 'textG', 1, 'textB', 0, 'text2', self.victims[victim].slayer, 'justify2', "RIGHT", 'text2R', 1, 'text2G', 1, 'text2B', 0);
 					else
						victims:AddLine('text', self.victims[victim].name, 'justify', "LEFT", 'textR', 1, 'textG', 1, 'textB', 0);
					end
				end
			end
		end
	end
	if tonumber(self.db.profile.mtimer) > 0 and multi > 0 then
		self:ScheduleEvent(self.UpdateTooltip, 1, self);
	end
end

function KillingSpree:PLAYER_ENTERING_WORLD()
	self:SetAddonVariables();
	self:UpdateTooltip();
end

function KillingSpree:CHAT_MSG_ADDON(addon, message, channel, source)
	if self.db.profile.shared and addon == "KillingSpree" and source ~= UnitName("player") then
		local _, _, multikills, spreekills, mtimer, slain = string.find(message, "MultiKills:(%d+) SpreeKills:(%d+) MultiTimer:(%d+)  SlainCheck:(%s+)");
		if self.db.profile.debug then
			self:Print(string.format("CHAT_MSG_ADDON: addon=%s message=%s channel=%s source=%s", tostring(addon) or "nil", totring(message) or "nil", tostring(channel) or "nil", tostring(source) or "nil"));
		end
		if self.db.profile.sounds then
			PlaySoundFile("Sound\\Doodad\\BellTollNightElf.wav");
		end
		self:Announce(string.format("%s is on a killing spree [x%s]", source, spreekills or multikills));
	end
end

function KillingSpree:PLAYER_DEAD(info)
	local self = KillingSpree;
	local taunt = math.random(1, 20);
	if self.db.profile.debug then
		self:Print(string.format("PLAYER_DEAD: sourceID=%s sourceName=%s sourcePvP=%s recipientID=%s recipientName=%s recipientPvP=%s abilityName=%s isItem=%s event=", tostring(info.sourceID) or "nil", tostring(info.sourceName) or "nil", tostring(info.sourcePvP) or "false", tostring(info.recipientID) or "nil", tostring(info.recipientName) or "nil", tostring(info.recipientPvP) or "false", tostring(info.abilityName) or "nil", tostring(info.isItem) or "false", tostring(info.event) or "nil"));
	end
	if self.db.profile.sounds then
		PlaySoundFile("Interface\\AddOns\\KillingSpree\\snds\\Taunts\\" .. SOUND_SCHEME["Taunts"][taunt][1]);
	end
	self:Announce(string.format("%s", SOUND_SCHEME["Taunts"][taunt][2]));
	self:SetAddonVariables();
	self:UpdateTooltip();
end

function KillingSpree:HOSTILE_DEAD(info)
	local self = KillingSpree;
	local sound = nil;
	if self.db.profile.debug then
		self:Print(string.format("HOSTILE_DEAD: sourceID=%s sourceName=%s sourcePvP=%s recipientID=%s recipientName=%s recipientPvP=%s abilityName=%s isItem=%s event=", tostring(info.sourceID) or "nil", tostring(info.sourceName) or "nil", tostring(info.sourcePvP) or "false", tostring(info.recipientID) or "nil", tostring(info.recipientName) or "nil", tostring(info.recipientPvP) or "false", tostring(info.abilityName) or "nil", tostring(info.isItem) or "false", tostring(info.event) or "nil"));
	end
	if not self.victims[self.kills] then
		self.victims[self.kills] = {};
	end
	self.victims[self.kills].tod = time();
	self.victims[self.kills].name = info.recipientName;
	if info.sourceID == "player" or info.sourceID == "pet" then
		self.victims[self.kills].slayer = "You";
	else
		self.victims[self.kills].slayer = info.sourceName;
	end
	if not self.victims[self.kills].announced then
		self.victims[self.kills].announced = true;
		self:UpdateTooltip();
		self.kills = self.kills + 1;
		if tonumber(self.db.profile.mtimer) == 0 then
			self.multi = self.spree;
		end
		if self.multi > self.db.char.multi then
			self.db.char.multi = self.multi;
		end
		if self.spree > self.db.char.spree then
			self.db.char.spree = self.spree;
		end
		if self.spree >= 10 and self.spree/5 == floor(self.spree/5) then
			sound = self.spree;
			if self.db.profile.shared and self.broadcasted < self.spree then
				self.broadcasted = self.spree;
				local message = string.format("MultiKills:%d SpreeKills:%d MultiTimer:%d SlainCheck:%s", self.multi, self.spree, self.db.profile.mtimer, tostring(self.db.profile.slain));
				if GetZoneText() == "Warsong Gulch" or GetZoneText() == "Arathi Basin" or GetZoneText() == "Alterac Valley" or GetZoneText() == "Eye of the Storm" then
					SendAddonMessage("KillingSpree", message, "BATTLEGROUND");
				elseif UnitInParty("player") or UnitInRaid("player") then
					SendAddonMessage("KillingSpree", message, "RAID");
				end
			end
		elseif self.multi > 1 and self.multi < 10 then
			sound = self.multi;
		elseif self.spree == 1 then
			if self.first == 0 then
				self.first = 1;
				sound = 1;
			end
		end
		if self.displayed < self.spree then
			self.displayed = self.spree;
			if SOUND_SCHEME[self.db.profile.scheme][sound] then
				if self.db.profile.sounds then
					PlaySoundFile("Interface\\AddOns\\KillingSpree\\snds\\" .. self.db.profile.scheme .. "\\" .. SOUND_SCHEME[self.db.profile.scheme][sound][1]);
				end
				self:Announce(string.format("%s [x%d]", SOUND_SCHEME[self.db.profile.scheme][sound][2], sound));
			end
			if self.db.profile.visuals then
				UIFrameFlash(LowHealthFrame, 0.25, 0.25, 0.5, false, 0, 0);
			end
		end
	end
end

function KillingSpree:Announce(message)
	if IsAddOnLoaded("sct") and self.db.profile.frame == "sct" then
		SCT:DisplayMessage(message, self.db.profile.fontcolor);
	elseif IsAddOnLoaded("Parrot") and self.db.profile.frame == "parrot" then
		Parrot:ShowMessage(message, "Notification", false, self.db.profile.fontcolor.r, self.db.profile.fontcolor.g, self.db.profile.fontcolor.b);
	elseif IsAddOnLoaded("MikScrollingBattleText") and self.db.profile.frame == "msbt" then
		MikSBT.DisplayMessage(message, MikSBT.DISPLAYTYPE_NOTIFICATION, false, self.db.profile.fontcolor.r, self.db.profile.fontcolor.g, self.db.profile.fontcolor.b);
	elseif UIOptionsFrameCheckButtons["SHOW_COMBAT_TEXT_TEXT"].value == "1" and self.db.profile.frame == "blizzard" then
		CombatText_AddMessage(message, COMBAT_TEXT_SCROLL_FUNCTION, self.db.profile.fontcolor.r, self.db.profile.fontcolor.g, self.db.profile.fontcolor.b);
	else
		self.MessageFrame:AddMessage(message, self.db.profile.fontcolor.r, self.db.profile.fontcolor.g, self.db.profile.fontcolor.b);
	end
end

function KillingSpree:ToggleMessageFrame()
	if not self.locked then
		self.MessageFrame:RegisterForDrag("LeftButton");
		self.MessageFrame:SetMovable(true);
		self.MessageFrame:EnableMouse(true);
		self.MessageFrame:SetBackdropColor(1.0, 1.0, 1.0, 0.2);
		self.MessageFrame:SetBackdropBorderColor(1.0, 1.0, 1.0, 0.2);
		self.MessageFrame:SetScript("OnDragStart", function () self.MessageFrame:StartMoving(); end)
		self.MessageFrame:SetScript("OnDragStop", function() self.MessageFrame:StopMovingOrSizing(); end)
		self.MessageFrame:SetPoint("CENTER", UIParent, "CENTER", self.db.profile.x, self.db.profile.y);
	else
		self.MessageFrame:RegisterForDrag();
		self.MessageFrame:SetMovable(false);
		self.MessageFrame:EnableMouse(false);
		self.MessageFrame:SetBackdropColor(1.0, 1.0, 1.0, 0.0);
		self.MessageFrame:SetBackdropBorderColor(1.0, 1.0, 1.0, 0.0);
		_, _, _, self.db.profile.x, self.db.profile.y = self.MessageFrame:GetPoint();
	end
end

function KillingSpree:CreateMessageFrame()
	self.MessageFrame = CreateFrame("MessageFrame");
	self.MessageFrame:SetInsertMode("BOTTOM");
	self.MessageFrame:SetFrameStrata("HIGH");
	self.MessageFrame:SetJustifyH("CENTER");
	self.MessageFrame:SetToplevel(true);
	self.MessageFrame:SetHeight(100);
	self.MessageFrame:SetWidth(600);
	self.MessageFrame:SetFading(true);
	self.MessageFrame:SetTimeVisible(3);
	self.MessageFrame:SetFadeDuration(3);
	self.MessageFrame:SetPoint("CENTER", UIParent, "CENTER", self.db.profile.x, self.db.profile.y);
	self.MessageFrame:SetTextColor(self.db.profile.fontcolor.r, self.db.profile.fontcolor.g, self.db.profile.fontcolor.b);
	self.MessageFrame:SetFont(self.sharedmedia:Fetch('font', self.db.profile.fonttype), tonumber(self.db.profile.fontsize), self.db.profile.fontoutline);
 	self.MessageFrame:SetBackdrop({ bgFile = "Interface/Tooltips/UI-Tooltip-Background", edgeSize = 16, edgeFile = "Interface/Tooltips/UI-Tooltip-Border", tile = true, tileSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 }});
end

function KillingSpree:SetCombatLogRange(type)
	if type == "minimum" then
		SetCVar("CombatDeathLogRange", 30);
		SetCVar("CombatLogRangeParty", 30);
		SetCVar("CombatLogRangePartyPet", 30);
		SetCVar("CombatLogRangeCreature", 30);
		SetCVar("CombatLogRangeHostilePlayers", 30);
		SetCVar("CombatLogRangeFriendlyPlayers", 30);
		SetCVar("CombatLogRangeHostilePlayersPets", 30);
		SetCVar("CombatLogRangeFriendlyPlayersPets", 30);
	elseif type == "default" then
		SetCVar("CombatDeathLogRange", 60);
		SetCVar("CombatLogRangeParty", 50);
		SetCVar("CombatLogRangePartyPet", 50);
		SetCVar("CombatLogRangeCreature", 30);
		SetCVar("CombatLogRangeHostilePlayers", 50);
		SetCVar("CombatLogRangeFriendlyPlayers", 50);
		SetCVar("CombatLogRangeHostilePlayersPets", 50);
		SetCVar("CombatLogRangeFriendlyPlayersPets", 50);
	elseif type == "optimum" then
		SetCVar("CombatDeathLogRange", 120);
		SetCVar("CombatLogRangeParty", 100);
		SetCVar("CombatLogRangePartyPet", 100);
		SetCVar("CombatLogRangeCreature", 60);
		SetCVar("CombatLogRangeHostilePlayers", 100);
		SetCVar("CombatLogRangeFriendlyPlayers", 100);
		SetCVar("CombatLogRangeHostilePlayersPets", 100);
		SetCVar("CombatLogRangeFriendlyPlayersPets", 100);
	elseif type == "maximum" then
		SetCVar("CombatDeathLogRange", 150);
		SetCVar("CombatLogRangeParty", 150);
		SetCVar("CombatLogRangePartyPet", 150);
		SetCVar("CombatLogRangeCreature", 150);
		SetCVar("CombatLogRangeHostilePlayers", 150);
		SetCVar("CombatLogRangeFriendlyPlayers", 150);
		SetCVar("CombatLogRangeHostilePlayersPets", 150);
		SetCVar("CombatLogRangeFriendlyPlayersPets", 150);
	end
end

function KillingSpree:SetAddonVariables()
	self.victims = {};
	self.kills = 0;
	self.first = 0;
	self.multi = 0;
	self.spree = 0;
	self.displayed = 0;
	self.broadcasted = 0;
end

